/**************************************************************
 * Copyright (C) 2001 Alex Rozin, Optical Access
 *
 *                     All Rights Reserved
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * ALEX ROZIN DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * ALEX ROZIN BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 ******************************************************************/

#ifndef _MIBGROUP_EVENT_H
#define _MIBGROUP_EVENT_H

#include "../../vtk.h"

config_require(util_funcs)

/*
 * File scope definitions section 
 */

#define eventEntryFirstIndexBegin       11

#define EVENTINDEX              1
#define EVENTDESCRIPTION        2
#define EVENTTYPE               3
#define EVENTCOMMUNITY          4
#define EVENTLASTTIMESENT       5
#define EVENTOWNER              6
#define EVENTSTATUS             7

#define Leaf_event_description      2
#define Leaf_event_type             3
#define Leaf_event_community        4
#define Leaf_event_last_time_sent   5
#define Leaf_eventOwner             6
#define Leaf_eventStatus            7

#define MIN_event_description   0
#define MAX_event_description   127

#define MIN_event_community     0
#define MAX_event_community     127

#define LOGEVENTINDEX           1
#define LOGINDEX                2
#define LOGTIME                 3
#define LOGDESCRIPTION          4

#define MAX_LOG_ENTRIES_PER_CTRL	200

#define MAX_EventTable_rowNumber MAXIMUM_PORT

/*
 * function prototypes 
 */
void init_event(void);

#endif                          /* _MIBGROUP_EVENT_H */

