/**************************************************************
 * Copyright (C) 2001 Alex Rozin, Optical Access 
 *
 *                     All Rights Reserved
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation.
 * 
 * ALEX ROZIN DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * ALEX ROZIN BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 ******************************************************************/

#ifndef _MIBGROUP_HISTORY_H
#define _MIBGROUP_HISTORY_H

#include "../../vtk.h"

config_require(util_funcs)

/*
 * File scope definitions section 
 */

#define historyControlEntryFirstIndexBegin      11

#define CTRL_INDEX		        1
#define CTRL_DATASOURCE		    2
#define CTRL_BUCKETSREQUESTED	3
#define CTRL_BUCKETSGRANTED	    4
#define CTRL_INTERVAL		    5
#define CTRL_OWNER		        6
#define CTRL_STATUS		        7

#define DATA_INDEX		    1
#define DATA_SAMPLEINDEX	2
#define DATA_INTERVALSTART	3
#define DATA_DROPEVENTS		4
#define DATA_OCTETS		    5
#define DATA_PKTS		    6
#define DATA_BROADCASTPKTS	7
#define DATA_MULTICASTPKTS	8
#define DATA_CRCALIGNERRORS	9
#define DATA_UNDERSIZEPKTS	10
#define DATA_OVERSIZEPKTS	11
#define DATA_FRAGMENTS		12
#define DATA_JABBERS		13
#define DATA_COLLISIONS		14
#define DATA_UTILIZATION	15

#define MAX_BUCKETS_IN_CRTL_ENTRY	50
#define HIST_DEF_BUCK_REQ		    50
#define HIST_DEF_INTERVAL		    1800

#define Leaf_historyControlDataSource                    2
#define Leaf_historyControlBucketsRequested              3
#define Leaf_historyControlInterval                      5
#define Leaf_historyControlOwner                         6
#define Leaf_historyControlStatus                        7

#define MIN_historyControlBucketsRequested               1
#define MAX_historyControlBucketsRequested               65535

#define MIN_historyControlInterval                       1
#define MAX_historyControlInterval                       3600

#define MAX_HistoryTable_rowNumber MAXIMUM_PORT

/*
 * function prototypes 
 */
void init_history(void);

#endif                          /* _MIBGROUP_HISTORY_H */

