/**************************************************************
 * Copyright (C) 2001 Tali Rozin, Optical Access
 *
 *                     All Rights Reserved
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * TALI ROZIN DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * ALEX ROZIN BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 ******************************************************************/

#ifndef _statistics_h_included__
#define _statistics_h_included__


#include "../../vtk.h"

config_require(util_funcs)

void init_statistics(void);

/*
 * File scope definitions section 
 */

#define MIB_DESCR	"EthStat"

#define IDetherStatsIndex       1
#define IDetherStatsDataSource  2
#define IDetherStatsDropEvents  3
#define IDetherStatsOctets      4
#define IDetherStatsPkts        5
#define IDetherStatsBroadcastPkts   6
#define IDetherStatsMulticastPkts   7
#define IDetherStatsCRCAlignErrors  8
#define IDetherStatsUndersizePkts   9
#define IDetherStatsOversizePkts    10
#define IDetherStatsFragments       11
#define IDetherStatsJabbers         12
#define IDetherStatsCollisions      13
#define IDetherStatsPkts64Octets    14
#define IDetherStatsPkts65to127Octets       15
#define IDetherStatsPkts128to255Octets      16
#define IDetherStatsPkts256to511Octets      17
#define IDetherStatsPkts512to1023Octets     18
#define IDetherStatsPkts1024to1518Octets    19
#define IDetherStatsOwner       20
#define IDetherStatsStatus      21

#define etherStatsEntryFirstIndexBegin	11

#define Leaf_etherStatsDataSource       2
#define Leaf_etherStatsOwner            20
#define Leaf_etherStatsStatus           21

#define MIN_etherStatsIndex             1
#define MAX_etherStatsIndex             65535


#define MAX_StatisticsTable_rowNumber MAXIMUM_PORT


#endif                          /* _statistics_h_included__ */

/*
 * end of file statistics.h 
 */
