
/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.3 2002/10/17 09:40:46 dts12 Exp $
 */

// *********************************************************************** //
// PART 1-1: [Header]--Include Important Headers                           //
// *********************************************************************** //
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

// *********************************************************************** //
// PART 1-2: [Header]--Include Our .h file                                 //
// *********************************************************************** // 
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <asm/param.h>
#include "../../vtk.h"
#include "../../net_snmp_handle.h"
#include "dot1dBase.h"

// *********************************************************************** //
// PART 2-1: [MIB Tree]--Define oid Array                                  //
// *********************************************************************** //
/* 
 * dot1dBase_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
oid dot1dBase_variables_oid[] = { SNMP_OID_MIB2, 17, 1 };

// *********************************************************************** //
// PART 2-2: [MIB Tree]--Define struct variable4 Array                     //
// *********************************************************************** //
/* 
 * variable4 dot1dBase_variables:
 *   this variable defines function callbacks and type return information 
 *   for the  mib section 
 */

struct variable4 dot1dBase_variables[] = {
    /*  magic number                   , variable type , ro/rw,  callback fn  , L, oidsuffix */
    {DOT1DBASEBRIDGEADDRESS,             ASN_OCTET_STR,  RONLY,  var_dot1dBase, 1,  { 1 }},
    {DOT1DBASENUMPORTS,                  ASN_INTEGER,    RONLY,  var_dot1dBase, 1,  { 2 }},
    {DOT1DBASETYPE,                      ASN_INTEGER,    RONLY,  var_dot1dBase, 1,  { 3 }},   
    {DOT1DBASEPORT,                      ASN_INTEGER,    RONLY,  var_dot1dBasePortTable, 3,  { 4, 1, 1 }},
    {DOT1DBASEPORTIFINDEX,               ASN_INTEGER,    RONLY,  var_dot1dBasePortTable, 3,  { 4, 1, 2 }},
    {DOT1DBASEPORTCIRCUIT,               ASN_OBJECT_ID,  RONLY,  var_dot1dBasePortTable, 3,  { 4, 1, 3 }},
    {DOT1DBASEPORTDELAYEXCEEDEDDISCARDS, ASN_COUNTER,    RONLY,  var_dot1dBasePortTable, 3,  { 4, 1, 4 }},
    {DOT1DBASEPORTMTUEXCEEDEDDISCARDS,   ASN_COUNTER,    RONLY,  var_dot1dBasePortTable, 3,  { 4, 1, 5 }},
};

// *********************************************************************** //
// PART 3-1  [User Data]--Data Declaration & Definition                    //
// *********************************************************************** //
/*
 * Global variables to store data we're interesting in serving:
 */
 
static dot1dBasePortEntry_rowNumber = 0;

static struct MIB_dot1dBaseScalar {                        
    unsigned char bridgeAddress[ETH_MAC_LEN]; // MacAddress - ASN_OCTET_STR        [1]*
    long numPorts;                  // INTEGER - ASN_INTEGER             [2]
    long type;                      // INTEGER - ASN_INTEGER             [3]
} dot1dBaseScalar;

static struct MIB_dot1dBasePortEntry{
    long port;                      // INTEGER - ASN_INTEGER             [4][1]
    long ifIndex;                   // INTEGER - ASN_INTEGER             [4][2]
    oid  circuit[MAX_OID_LEN];      // OBJECT IDENTIFIER - ASN_OBJECT_ID [4][3]*
    long circuit_len;               
    u_long delayExceededDiscards;   // Counter - ASN_INTEGER             [4][4]
    u_long mtuExceededDiscards;     // Counter - ASN_INTEGER             [4][5]
} dot1dBasePortEntry[MAX_dot1dBasePortEntry_rowNumber];


// *********************************************************************** //
// PART 3-2 [User Function]--Table Handle Function ProtoType Declaration   //
// *********************************************************************** //
void init_dot1dBaseTableGroup(void);
void init_dot1dBaseScalar(void);
void init_dot1dBasePortEntry(void);

// *********************************************************************** //
// PART 4-1 Init Functions                                                 //
// *********************************************************************** //
/** Initializes the dot1dBase module */
void init_dot1dBase(void)
{
    DEBUGMSGTL(("dot1dBase", "Initializing\n"));
  
 /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("dot1dBase", dot1dBase_variables, variable4, dot1dBase_variables_oid);

 /* place any other initialization junk you need here */
    init_dot1dBaseScalar();
    init_dot1dBasePortEntry();
}

// *********************************************************************** //
// PART 4-2  Initial Data by Hard Code                                     //
// char bridgeAddress[6];         MacAddress - ASN_OCTET_STR         [1]*
// long numPorts;                 INTEGER - ASN_INTEGER              [2]
// long type;                     INTEGER - ASN_INTEGER              [3]
// *********************************************************************** //
void  init_dot1dBaseScalar(void)
{
    memset ((u_char*)&dot1dBaseScalar.bridgeAddress[0], '\x01', ETH_MAC_LEN);   //[1]
    dot1dBaseScalar.numPorts = MAX_dot1dBasePortEntry_rowNumber;                //[2]
    dot1dBaseScalar.type = 2L;  //transparent-only                              //[3]
}

// *********************************************************************** //
// PART 5  User Table Handle Functon                                       //
// *********************************************************************** //

// *********************************************************************** //
// [5-1] User Table Handle Functon                                         //
// long port;                     INTEGER - ASN_INTEGER              [4][1]
// long ifIndex;                  INTEGER - ASN_INTEGER              [4][2]
// oid  circuit[MAX_OID_LEN];     OBJECT IDENTIFIER - ASN_OBJECT_ID  [4][3]*
// long circuit_len;               
// u_long delayExceededDiscards;  Counter - ASN_INTEGER              [4][4]
// u_long mtuExceededDiscards;    Counter - ASN_INTEGER              [4][5]
// *********************************************************************** //
int append_dot1dBasePortEntry( long port, long ifIndex, 
                               char *circuit, u_long mtuExceededDiscards,
                               u_long delayExceededDiscards )
{
    int         row;
    oid         outOid[MAX_OID_LEN];
    u_long      oidLen;
   
    if( dot1dBasePortEntry_rowNumber == MAX_dot1dBasePortEntry_rowNumber )
        return -1; //[error check]

    row = dot1dBasePortEntry_rowNumber;
    memset( (char*)&dot1dBasePortEntry[row], 0, sizeof(struct MIB_dot1dBasePortEntry) );

    dot1dBasePortEntry[row].port = port;                                    //[1]
    dot1dBasePortEntry[row].ifIndex = ifIndex;                              //[2]

    oidLen = parse_miboid(circuit, &outOid);
    memcpy(dot1dBasePortEntry[row].circuit, outOid, oidLen*sizeof(oid));    //[3]
    dot1dBasePortEntry[row].circuit_len = oidLen; 

    dot1dBasePortEntry[row].mtuExceededDiscards = mtuExceededDiscards;      //[4]
    dot1dBasePortEntry[row].delayExceededDiscards = delayExceededDiscards;  //[5]

    dot1dBasePortEntry_rowNumber++;
    return 0;
}

struct MIB_dot1dStpPortEntry *get_dot1dBasePortEntry(long index)
{
    long curr_index_value, row;
	
    curr_index_value = index;
    for( row=0 ; row < dot1dBasePortEntry_rowNumber ; row++ )
    {
        if( curr_index_value == dot1dBasePortEntry[row].port )
            break;
    }
	
    if( row == dot1dBasePortEntry_rowNumber )
        return NULL;

    return (struct MIB_dot1dBasePortEntry *)&dot1dBasePortEntry[row]; 
}

struct MIB_dot1dStpPortEntry *getnext_dot1dBasePortEntry(long index)
{
    long curr_index_value, row;

    curr_index_value = index;
    for( row=0 ; row < dot1dBasePortEntry_rowNumber; row++ )
    {
        if( curr_index_value < dot1dBasePortEntry[row].port )
            break;
    }

    if( row == dot1dBasePortEntry_rowNumber )
        return NULL;

    return (struct MIB_dot1dBasePortEntry*)&dot1dBasePortEntry[row]; 
}

// *********************************************************************** //
// PART 4-3  Initial Data by Hard Code                                     //
// long port;                     INTEGER - ASN_INTEGER              [4][1]
// long ifIndex;                  INTEGER - ASN_INTEGER              [4][2]
// oid  circuit[MAX_OID_LEN];     OBJECT IDENTIFIER - ASN_OBJECT_ID  [4][3]*
// long circuit_len;               
// u_long delayExceededDiscards;  Counter - ASN_INTEGER              [4][4]
// u_long mtuExceededDiscards;    Counter - ASN_INTEGER              [4][5]
// *********************************************************************** //
void init_dot1dBasePortEntry(void)
{
    long port;
    char circuit[] = ".0.0";
    long mtuExceededDiscards = 0L;
    long delayExceededDiscards = 0L;
    
    for( port=0L ; port < MAX_dot1dBasePortEntry_rowNumber ; port++ )
    {
        append_dot1dBasePortEntry( port + 1L, port + 1L, 
                                   circuit, mtuExceededDiscards,
                                   delayExceededDiscards);
    }
}

// *********************************************************************** //
// PART 6  SNMP Get/GetNext Variable_Handle Functon                        //
// *********************************************************************** //

// *********************************************************************** //
// [6-1]      SNMP Get/GetNext var_handle Functon                          //
// char bridgeAddress[6];         MacAddress - ASN_OCTET_STR         [1]*
// long numPorts;                 INTEGER - ASN_INTEGER              [2]
// long type;                     INTEGER - ASN_INTEGER              [3]
// *********************************************************************** //
/*
 * var_dot1dBase():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *var_dot1dBase( struct variable *vp, oid *name, 
                              size_t *length, int exact, size_t *var_len,
                              WriteMethod **write_method )
{
    static long             ulong_ret;
    static unsigned char    string[SPRINT_MAX_LEN];
    char                    mac[6];
    snmp_eventMsg_t         event;

    if( header_generic(vp, name, length, exact, var_len, write_method) == MATCH_FAILED )
        return NULL;

 /* This is where we do the value assignments for the mib results. */
    *var_len = sizeof(ulong_ret);
    switch( vp->magic )
    {
        case DOT1DBASEBRIDGEADDRESS:
            event.type=e_snmp_dot1dBase_system_mac_get;
            util_snmp_evtMsg_ack_handler( &event );            
            memcpy(string, event.string, ETH_MAC_LEN);                                        
            
            *var_len = ETH_MAC_LEN;            
            return (u_char*) &string;

        case DOT1DBASENUMPORTS:
            ulong_ret = dot1dBaseScalar.numPorts;
            return (u_char*) &ulong_ret;

        case DOT1DBASETYPE:
            ulong_ret = dot1dBaseScalar.type;
            return (u_char*) &ulong_ret;

        default:
            ERROR_MSG("var_dot1dBase() Fail");
            return NULL;
    }
}

// *********************************************************************** 
// [7-1]     SNMP Get/GetNext Table_Handle Functon               
// long port;                     INTEGER - ASN_INTEGER              [4][1]
// long ifIndex;                  INTEGER - ASN_INTEGER              [4][2]
// oid  circuit[MAX_OID_LEN];     OBJECT IDENTIFIER - ASN_OBJECT_ID  [4][3]*
// long circuit_len;               
// u_long delayExceededDiscards;  Counter - ASN_INTEGER              [4][4]
// u_long mtuExceededDiscards;    Counter - ASN_INTEGER              [4][5]
// ********************************************************************** 
/*
 * var_dot1dBasePortTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_ above.
 */
unsigned char *var_dot1dBasePortTable( struct variable *vp, oid *name, 
                                       size_t *length, int exact,
                                       size_t *var_len, WriteMethod **write_method )
{
    static u_long       ulong_ret;
    static oid          objid[MAX_OID_LEN];
    u_long              oidLen;
    u_long              index;
    snmp_eventMsg_t     event;
    struct MIB_dot1dBasePortEntry    *geptr;

    /*  Set up write_method first, in case we return NULL before getting to
        the switch (vp->magic) below.  In some of these cases, we still want
        to call the appropriate write_method, if only to have it return the
        appropriate error.  */
    *write_method = NULL;

    if( memcmp(name, vp->name, sizeof(oid)*vp->namelen) != 0 )
    {
        memcpy(name, vp->name, sizeof(oid)*vp->namelen);
        *length = vp->namelen;
    }

 /* the value of exact means it has interface number or not. */
    if( exact )
    {
        if( *length != 12 )
            return NULL;

        index = name[11];
        geptr = get_dot1dBasePortEntry(index);
    }
    else
    {
        index = *length>11 ? name[11] : 0;
        geptr = getnext_dot1dBasePortEntry(index);
        if( geptr )
        {
    	    name[11] = geptr->port;
    	    *length = 12;
        }
    }

    if( geptr == NULL )
        return NULL;

 /* This is where we do the value assignments for the mib results. */
    *var_len = sizeof(ulong_ret);
    memset( &event, 0, sizeof(snmp_eventMsg_t) );
    event.port = (unsigned int)index+1;
    switch( vp->magic )
    {
        case DOT1DBASEPORT:                         /* [1] */
            ulong_ret = event.port;
            return (u_char *)&ulong_ret;

        case DOT1DBASEPORTIFINDEX:                  /* [2] */
            ulong_ret = event.port;
            return (u_char *)&ulong_ret;

        case DOT1DBASEPORTCIRCUIT:                  /* [3] */
            oidLen = dot1dBasePortEntry[event.port].circuit_len;
            *var_len = oidLen * sizeof(oid);
            memcpy(objid, dot1dBasePortEntry[event.port].circuit, oidLen * sizeof(oid));
            return (u_char *)&objid;

        case DOT1DBASEPORTDELAYEXCEEDEDDISCARDS:    /* [4] */
            event.type=e_snmp_dot1dBasePortDelayExceededDiscards_get;
            util_snmp_evtMsg_ack_handler( &event );
            ulong_ret=event.val;
            return (u_char *)&ulong_ret;

        case DOT1DBASEPORTMTUEXCEEDEDDISCARDS:      /* [5] */
            event.type=e_snmp_dot1dBasePortMtuExceededDiscards_get;
            util_snmp_evtMsg_ack_handler( &event );
            ulong_ret=event.val;
            return (u_char *)&ulong_ret;

        default:                                                         
            ERROR_MSG("var_dot1dBasePortTable(), Type Error!");
    }
    return NULL;
}
