
/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.3 2002/10/17 09:40:46 dts12 Exp $
 */

// *********************************************************************** //
// PART 1-1: [Header]--Include Important Headers                           //
// *********************************************************************** //
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

// *********************************************************************** //
// PART 1-2: [Header]--Include Our .h file                                 //
// *********************************************************************** // 
#include "dot1dTp.h"

#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
//#include "../../vtk.h"
#include "../../net_snmp_handle.h"
#include "../lib/util_if.h"

// *********************************************************************** //
// PART 2-1: [MIB Tree]--Define oid Array                                  //
// *********************************************************************** //
/* 
 * dot1dTp_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
oid dot1dTp_variables_oid[] = { SNMP_OID_MIB2, 17, 4 };

// *********************************************************************** //
// PART 2-2: [MIB Tree]--Define struct variable4 Array                     //
// *********************************************************************** //
/* 
 * variable4 dot1dTp_variables:
 *   this variable defines function callbacks and type return information 
 *   for the  mib section 
 */

struct variable4 dot1dTp_variables[] = {
    /*  magic number              , variable type , ro/rw , callback fn  , L, oidsuffix */
    {DOT1DTPLEARNEDENTRYDISCARDS, ASN_COUNTER,   RONLY,  var_dot1dTp,          1, { 1 }},
    {DOT1DTPAGINGTIME,            ASN_INTEGER,   RWRITE, var_dot1dTp,          1, { 2 }},
    {DOT1DTPFDBADDRESS,           ASN_OCTET_STR, RONLY,  var_dot1dTpFdbTable,  3, { 3, 1, 1 }},
    {DOT1DTPFDBPORT,              ASN_INTEGER,   RONLY,  var_dot1dTpFdbTable,  3, { 3, 1, 2 }},
    {DOT1DTPFDBSTATUS,            ASN_INTEGER,   RONLY,  var_dot1dTpFdbTable,  3, { 3, 1, 3 }},
    {DOT1DTPPORT,                 ASN_INTEGER,   RONLY,  var_dot1dTpPortTable, 3, { 4, 1, 1 }},
    {DOT1DTPPORTMAXINFO,          ASN_INTEGER,   RONLY,  var_dot1dTpPortTable, 3, { 4, 1, 2 }},
    {DOT1DTPPORTINFRAMES,         ASN_COUNTER,   RONLY,  var_dot1dTpPortTable, 3, { 4, 1, 3 }},
    {DOT1DTPPORTOUTFRAMES,        ASN_COUNTER,   RONLY,  var_dot1dTpPortTable, 3, { 4, 1, 4 }},
    {DOT1DTPPORTINDISCARDS,       ASN_COUNTER,   RONLY,  var_dot1dTpPortTable, 3, { 4, 1, 5 }},
};

// *********************************************************************** //
// PART 3-1 [User Data]--Data Declaration & Definition                     //
// *********************************************************************** //
/*
 * Global variables to store data we're interesting in serving:
 */
static dot1dTpFdbEntry_rowNumber  = 0;
static dot1dTpPortEntry_rowNumber = 0;
int table_rebuild = 1;

static struct MIB_dot1dTpScalar {
    u_long learnedEntryDiscards;    // Counter - ASN_COUNTER           [1]
    long agingTime;                 // INTEGER - ASN_INTEGER           [2]rw
} dot1dTpScalar;

static struct MIB_dot1dTpFdbEntry{
    unsigned char address[6];       // MacAddress - ASN_OCTET_STR      [3][1]*
    long port;                      // INTEGER - ASN_INTEGER           [3][2]
    long status;                    // INTEGER - ASN_INTEGER           [3][3]
} dot1dTpFdbEntry[MAX_dot1dTpFdbEntry_rowNumber];

static struct MIB_dot1dTpPortEntry{
    long port;                      // INTEGER - ASN_INTEGER           [4][1]
    long maxInfo;                   // INTEGER - ASN_INTEGER           [4][2]
    u_long inFrames;                // Counter - ASN_COUNTER           [4][3]
    u_long outFrames;               // Counter - ASN_COUNTER           [4][4]
    u_long inDiscards;              // Counter - ASN_COUNTER           [4][5]
} dot1dTpPortEntry[MAX_dot1dTpPortEntry_rowNumber];

// ***********************************************************************
// PART 3-2 [User Function]--Table Handle Function ProtoType Declaration
// ***********************************************************************
void init_dot1dTp(void);
void init_dot1dTpScalar(void);
void init_dot1dTpFdbEntry(void);
void init_dot1dTpPortEntry(void);

// ***********************************************************************
// PART 4-1 Init Functions
// ***********************************************************************
/** Initializes the dot1dTp module */
void init_dot1dTp(void)
{
    DEBUGMSGTL(("dot1dTp", "Initializing\n"));

 /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("dot1dTp", dot1dTp_variables, variable4, dot1dTp_variables_oid);

 /* place any other initialization junk you need here */
    init_dot1dTpScalar();
    init_dot1dTpFdbEntry();
    init_dot1dTpPortEntry();
}

// ***********************************************************************
// PART 4-2  Initial Data by Hard Code
// u_long learnedEntryDiscards;   Counter - ASN_COUNTER              [1]
// long agingTime;                INTEGER - ASN_INTEGER              [2]rw
// ***********************************************************************
void init_dot1dTpScalar(void)
{
    dot1dTpScalar.learnedEntryDiscards = 0L;                           //[1]
    dot1dTpScalar.agingTime = 300L;                                    //[2]
}

// ***********************************************************************
// PART 5  User Table Handle Functon
// ***********************************************************************

// ***********************************************************************
// [5-1] User Table Handle Functon
// unsigned char address[6];      MacAddress - ASN_OCTET_STR         [3][1]*
// long port;                     INTEGER - ASN_INTEGER              [3][2]
// long status;                   INTEGER - ASN_INTEGER              [3][3]
// ***********************************************************************
int append_dot1dTpFdbEntry(unsigned char *address, long port, long status)
{
    int row;

    if( dot1dTpFdbEntry_rowNumber == MAX_dot1dTpFdbEntry_rowNumber )
        return -1; //[error check]

    row = dot1dTpFdbEntry_rowNumber;
    memset((u_char*)&dot1dTpFdbEntry[row], 0, sizeof(struct MIB_dot1dTpFdbEntry));  //[init]

    memcpy(dot1dTpFdbEntry[row].address, address, ETH_MAC_LEN);         //[1]
    dot1dTpFdbEntry[row].port = port;                                   //[2]
    dot1dTpFdbEntry[row].status = status;                               //[3]

    dot1dTpFdbEntry_rowNumber++;
    return 0;
}

// ***********************************************************************
// PART 4-3  Initial Data by Hard Code
// unsigned char address[6];      MacAddress - ASN_OCTET_STR         [3][1]*
// long port;                     INTEGER - ASN_INTEGER              [3][2]
// long status;                   INTEGER - ASN_INTEGER              [3][3]
// ***********************************************************************
void init_dot1dTpFdbEntry(void)
{
    unsigned char mac[ETH_MAC_LEN + 1];

    memset((u_char*)&mac[0], '\0', ETH_MAC_LEN + 1);

    mac[0]=0x00; mac[1]=0x00; mac[2]=0xe2; mac[3]=0x23; mac[4]=0x2f; mac[5]=0x6a;
    append_dot1dTpFdbEntry(mac, 31L, 3L);

    mac[0]=0x00; mac[1]=0x00; mac[2]=0xe8; mac[3]=0x1f; mac[4]=0xf8; mac[5]=0x03;
    append_dot1dTpFdbEntry(mac, 25L, 3L );
    
    mac[0]=0x55; mac[1]=0x00; mac[2]=0xe8; mac[3]=0x1f; mac[4]=0xf8; mac[5]=0x03;
    append_dot1dTpFdbEntry(mac, 26L, 3L );
    
    mac[0]=0x66; mac[1]=0x00; mac[2]=0xe8; mac[3]=0x1f; mac[4]=0xf8; mac[5]=0x03;
    append_dot1dTpFdbEntry(mac, 27L, 3L );        
}

// ***********************************************************************
// [5-2] User Table Handle Functon
// long port;                      // INTEGER - ASN_INTEGER           [4][1]
// long maxInfo;                   // INTEGER - ASN_INTEGER           [4][2]
// u_long inFrames;                // Counter - ASN_COUNTER           [4][3]
// u_long outFrames;               // Counter - ASN_COUNTER           [4][4]
// u_long inDiscards;              // Counter - ASN_COUNTER           [4][5]
// ***********************************************************************
void append_dot1dTpPortEntry( long port, long maxInfo, 
                              u_long inFrames, u_long outFrames,
                              u_long inDiscards )
{         	
    int row;
   
    if( dot1dTpPortEntry_rowNumber == MAX_dot1dTpPortEntry_rowNumber )
        return;

    row = dot1dTpPortEntry_rowNumber;
    memset( (u_char*)&dot1dTpPortEntry[row], 0, sizeof(struct MIB_dot1dTpPortEntry) );                             //[init]

    dot1dTpPortEntry[row].port = port;                              //[1]
    dot1dTpPortEntry[row].maxInfo = maxInfo;                        //[2]
    dot1dTpPortEntry[row].inFrames = inFrames;                      //[3]
    dot1dTpPortEntry[row].outFrames = outFrames;                    //[4]
    dot1dTpPortEntry[row].inDiscards = inDiscards;                  //[5]

    dot1dTpPortEntry_rowNumber++;
}

// ***********************************************************************
// PART 4-4  Initial Data by Hard Code.
// long port;                      // INTEGER - ASN_INTEGER           [4][1]
// long maxInfo;                   // INTEGER - ASN_INTEGER           [4][2]
// u_long inFrames;                // Counter - ASN_COUNTER           [4][3]
// u_long outFrames;               // Counter - ASN_COUNTER           [4][4]
// u_long inDiscards;              // Counter - ASN_COUNTER           [4][5]
// ***********************************************************************
void init_dot1dTpPortEntry(void)
{
    long port;
    long maxInfo = 1524L;
    u_long inFrames = 0L;
    u_long outFrames = 0L;
    u_long inDiscards = 0L;
    
    for( port=0 ; port < MAX_dot1dTpPortEntry_rowNumber ; port++ )
        append_dot1dTpPortEntry(port + 1L, maxInfo, inFrames, outFrames, inDiscards);
}

// ***********************************************************************
// PART 6  SNMP Get/GetNext Variable_Handle Functon
// ***********************************************************************
// ***********************************************************************
// [6-1]      SNMP Get/GetNext var_handle Functon.
// u_long learnedEntryDiscards;   Counter - ASN_COUNTER              [1]
// long agingTime;                INTEGER - ASN_INTEGER              [2]rw
// ***********************************************************************
/*
 * var_dot1dTp():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *var_dot1dTp( struct variable *vp, oid *name, 
                            size_t *length, int exact, size_t *var_len,
                            WriteMethod **write_method)
{
    static u_long   ulong_ret;
    snmp_eventMsg_t event;

    if( header_generic(vp, name, length, exact, var_len, write_method) == MATCH_FAILED )
        return NULL;

 /* Set up write_method first, in case we return NULL before getting to
    the switch (vp->magic) below.  In some of these cases, we still want
    to call the appropriate write_method, if only to have it return the
    appropriate error.  */

    switch( vp->magic )
    {
        case DOT1DTPAGINGTIME:                                           //[2]
            *write_method = write_dot1dTpAgingTime;
            break;
        default:
            *write_method = NULL;
    }

 /* This is where we do the value assignments for the mib results. */
    memset( &event, 0, sizeof(snmp_eventMsg_t) );
    *var_len = sizeof(ulong_ret);
    switch( vp->magic )
    {
        case DOT1DTPLEARNEDENTRYDISCARDS:                                //[1]
            event.type=e_snmp_dot1dTpLearnedEntryDiscards_get;
            util_snmp_evtMsg_ack_handler( &event );
            ulong_ret=event.val;
            return (unsigned char *) &ulong_ret;

        case DOT1DTPAGINGTIME:                                           //[2]
            event.type=e_snmp_dot1dTpAgingTime_get;
            util_snmp_evtMsg_ack_handler( &event );
            ulong_ret = event.val;
            return (u_char*) &ulong_ret;

        default:
            ERROR_MSG("var_dot1dTp() Fail");
    }
    return NULL;
}

// *********************************************************************** //
// PART 7 SNMP Get/GetNext Table_Handle Functon                            //
// *********************************************************************** //
// *********************************************************************** //
// [7-1] SNMP Get/GetNext Table_Handle Functon                             //
// *********************************************************************** //
// *********************************************************************** //
// unsigned char address[6];      MacAddress - ASN_OCTET_STR         [3][1]*
// long port;                     INTEGER - ASN_INTEGER              [3][2]
// long status;                   INTEGER - ASN_INTEGER              [3][3]
// *********************************************************************** //
void rebuild_dot1dTpFdbEntry(void)
{
    u_char mac[6];
    unsigned short vid;
    signed long port;
    Dot1qTpFdbStatus status;
    u_short addr;
	int ret=0;


return;
/* @@@@@@@@@@@@ Justin Sheu. */

    dot1dTpFdbEntry_rowNumber = 0;

#if IS_TP_MIB_TEST
  	ret = Issu_Flush_dynamic_mac_table();
	printf("ret:%d Issu_Flush_dynamic_mac_table\n",ret);

    ret = Issu_Show_mac_ucast_first_byaddr(mac, &vid, &port, &status, &addr);
	printf("ret:%d MAC[%x:%x:%x:%x:%x:%x] Vid: %d, Port :%d status: %d addr: %d\n",
        ret,mac[0],mac[1],mac[2],mac[3],mac[4],mac[5],vid,port,status,addr);

	while (ret==0){
        ret = Issu_Show_mac_ucast_next_byaddr(mac, &vid, &port, &status, &addr);
	    printf("ret:%d MAC[%x:%x:%x:%x:%x:%x] Vid: %d, Port :%d status: %d addr: %d\n",
            ret,mac[0],mac[1],mac[2],mac[3],mac[4],mac[5],vid,port,status,addr);
    }
#endif

#if IS_TP_MIB_TEST
 	ret = Issu_Flush_dynamic_mac_table();
    printf("ret:%d Issu_Flush_dynamic_mac_table\n",ret);
#endif

    if (ret == 0) {
        #if IS_TP_MIB_TEST
        ret = Issu_Show_mac_ucast_first_byaddr(mac, &vid, &port, &status, &addr);
	    printf("ret:%d MAC[%x:%x:%x:%x:%x:%x] Vid: %d, Port :%d status: %d addr: %d\n",
            ret,mac[0],mac[1],mac[2],mac[3],mac[4],mac[5],vid,port,status,addr);
        #endif

        if( ret==0 )
            append_dot1dTpFdbEntry(mac, vid, status);

        while (ret==0){
            #if IS_TP_MIB_TEST
            ret = Issu_Show_mac_ucast_next_byaddr(mac, &vid, &port, &status, &addr);
   	        printf("ret:%d MAC[%x:%x:%x:%x:%x:%x] Vid: %d, Port :%d status: %d addr: %d\n",
                ret,mac[0],mac[1],mac[2],mac[3],mac[4],mac[5],vid,port,status,addr);
            #endif

            if( ret==0 )
                append_dot1dTpFdbEntry(mac, vid, status);
        }
    }
    else
        printf("[SNMP-MIB]Issu_Flush_dynamic_mac_table() ==> FAILL\n");
}

struct MIB_dot1dTpFdbEntry *get_dot1dTpFdbEntry(unsigned char *string)
{
    long            row;
    unsigned char   *curr_str;
    snmp_eventMsg_t event;	
    unsigned char none_mac[6]={0xff,0xff,0xff,0xff,0xff,0xff};		
	
    memset((u_char*)&dot1dTpFdbEntry[0], 0, sizeof(struct MIB_dot1dTpFdbEntry));  
   
    event.type=e_snmp_dot1dTpFdb_mac_get;
    memcpy(event.string, string, ETH_MAC_LEN);    
    util_snmp_evtMsg_ack_handler( &event );           
    
    memcpy(dot1dTpFdbEntry[0].address, event.string, ETH_MAC_LEN);         
    dot1dTpFdbEntry[0].port = event.port; 
    
    if( !memcmp(event.string, none_mac, 6) )
        return NULL;// [twh] not found    
    
    
    switch( event.val )
    {
        case 0:
            dot1dTpFdbEntry[0].status = 3L;  //learned(3)
            break;
        case 1:
            dot1dTpFdbEntry[0].status = 5L;  //mgmt(5) 
            break;            
        default:
            dot1dTpFdbEntry[0].status = 0;
            break;
    }
                                      
                               
    return (struct MIB_dot1dTpFdbEntry *)&dot1dTpFdbEntry[0];

	
    /*curr_str = string;
    for (row = 0; row < dot1dTpFdbEntry_rowNumber; row++) {
        if ( curr_str[0] == dot1dTpFdbEntry[row].address[0] &&
             curr_str[1] == dot1dTpFdbEntry[row].address[1] &&
             curr_str[2] == dot1dTpFdbEntry[row].address[2] &&
             curr_str[3] == dot1dTpFdbEntry[row].address[3] &&
             curr_str[4] == dot1dTpFdbEntry[row].address[4] &&
             curr_str[5] == dot1dTpFdbEntry[row].address[5] )
            break;
    }
	 
    if (row == dot1dTpFdbEntry_rowNumber) {
        return NULL;// [twh] not found
    } 
    return (struct MIB_dot1dTpFdbEntry *)&dot1dTpFdbEntry[row];*/ 
}

struct MIB_dot1dTpFdbEntry *getnext_dot1dTpFdbEntry(unsigned char *string)
{
    long            row;
    unsigned char   *curr_str;
    snmp_eventMsg_t event;	
    unsigned char none_mac[6]={0xff,0xff,0xff,0xff,0xff,0xff};	
	
    memset((u_char*)&dot1dTpFdbEntry[0], 0, sizeof(struct MIB_dot1dTpFdbEntry));  
   
    event.type=e_snmp_dot1dTpFdb_mac_getnext;
    memcpy(event.string, string, ETH_MAC_LEN);    
    util_snmp_evtMsg_ack_handler( &event );           
    
    memcpy(dot1dTpFdbEntry[0].address, event.string, ETH_MAC_LEN);         
    dot1dTpFdbEntry[0].port = event.port; 
    
  
    if( !memcmp(event.string, none_mac, 6) )
        return NULL;// [twh] not found
    
        
    if(event.port==0)//CPU
    {
        dot1dTpFdbEntry[0].status = 4L;           //self(4)
    }
    else
    {
        switch( event.val )
        {
            case 0:
                dot1dTpFdbEntry[0].status = 3L;  //learned(3)
                break;
            case 1:
                dot1dTpFdbEntry[0].status = 5L;  //mgmt(5) 
                break;            
            default:
                dot1dTpFdbEntry[0].status = 0;
                break;
        }      
    }
                                       
                               
    return (struct MIB_dot1dTpFdbEntry *)&dot1dTpFdbEntry[0];
           
    /*
    curr_str = string;
    
    for( row=0 ; row < dot1dTpFdbEntry_rowNumber ; row++ )
    {
        if( curr_str[0]<=dot1dTpFdbEntry[row].address[0] ) 
            if( curr_str[0]<dot1dTpFdbEntry[row].address[0] )
                break;
            else 
                if( curr_str[1]<=dot1dTpFdbEntry[row].address[1] ) 
                    if( curr_str[1]<dot1dTpFdbEntry[row].address[1] )
                        break;
                    else 
                        if( curr_str[2]<=dot1dTpFdbEntry[row].address[2] )
                            if( curr_str[2]<dot1dTpFdbEntry[row].address[2] )
                                break;
                            else 
                                if( curr_str[3]<=dot1dTpFdbEntry[row].address[3] ) 
                                    if( curr_str[3]<dot1dTpFdbEntry[row].address[3] )
                                        break;
                                    else 
                                        if( curr_str[4]<=dot1dTpFdbEntry[row].address[4] )
                                            if( curr_str[4]<dot1dTpFdbEntry[row].address[4] )
                                                break;
                                            else 
                                                if( curr_str[5]<dot1dTpFdbEntry[row].address[5] ) 
                                                    break;
    }

    if( row == dot1dTpFdbEntry_rowNumber )
        return NULL;// [twh] not found
printf("row=%d\n",row);
    return (struct MIB_dot1dTpFdbEntry *)&dot1dTpFdbEntry[row];*/ 
}

// *********************************************************************** 
// [7-2] SNMP Get/GetNext Table_Handle Functon               
// char unsigned address[6];      MacAddress - ASN_OCTET_STR         [3][1]*
// long port;                     INTEGER - ASN_INTEGER              [3][2]
// long status;                   INTEGER - ASN_INTEGER              [3][3]
// ********************************************************************** 
/*
 * var_dot1TpFdbTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_ above.
 */
unsigned char *var_dot1dTpFdbTable( struct variable *vp, oid *name, 
                                    size_t *length, int exact,
                                    size_t *var_len, WriteMethod **write_method )
{
    static u_long           ulong_ret;
    static unsigned char    string[SPRINT_MAX_LEN];
    u_long                  index, i;
    struct MIB_dot1dTpFdbEntry *geptr;
    snmp_eventMsg_t event;

    //StatusCode ret;
    /* check by nextget in table's first column filed */   //[twh][2004-01-07]
    /* if (table_rebuild_flag==1) -> build table */
    static int table_rebuild_flag = 1;
    /* check by nextget in table's last column filed */    //[twh][2004-01-07]
    /* if (rows_working_counter==0) -> set table_rebuild_flag=1 */
    static int rows_working_counter = 0;

    // 1,3,6,1,2,1,17,1,4,1,item
    //                      11 
    // 1,3,6,1,2,1,17,1,4,1,item, mac[6]
    //                               17 

 /* Set up write_method first, in case we return NULL before getting to
    the switch (vp->magic) below.  In some of these cases, we still want
    to call the appropriate write_method, if only to have it return the
    appropriate error.  */
    *write_method = NULL;


    if(table_rebuild == 1)
    {
       event.type=e_snmp_dot1dTpFdb_mac_getfirst;
       util_snmp_evtMsg_ack_handler( &event );                                     
       table_rebuild = 0;      
    }        

    //[step 2 of 5][twh][for short oid]
    if (memcmp(name, vp->name, sizeof(oid)*vp->namelen) != 0) 
    {
        memcpy(name, vp->name, sizeof(oid)*vp->namelen);
        *length = vp->namelen;
        table_rebuild = 1;     
    }


    if (exact) 
    { //[twh][get, set]
        if (*length != 17)
            return NULL;

        //index = name[11];
        for (i = 0; i < 6; i++)
            string[i] = name[11 + i];
        string[i] = '\0';
        geptr = get_dot1dTpFdbEntry(string);
    } 
    else 
    {   //[twh][getnext]
        //index = *length>11 ? name[11] : 0;          
        if (*length > 16) 
        {
            for (i = 0; i < 6; i++)
                string[i] = name[11 + i];
            string[i] = '\0';           
        } 
        else 
        {
            memset(string, '\0', 7);
        }

        //[twh][92:05:23] for table: first time index==0
        geptr = getnext_dot1dTpFdbEntry(string);   
        if (geptr) 
        {                       
    	    //name[11] = geptr->port;
            for (i = 0; i < 6; i++)
               name[11 + i] = geptr->address[i]; 
    	      *length = 17;
        } 	
    }	

    if( geptr == NULL )
        return NULL;

    *var_len = sizeof(ulong_ret);
	
 /* This is where we do the value assignments for the mib results. */
    switch( vp->magic )
    {
        case DOT1DTPFDBADDRESS:                                          //[1]
            if( !exact )
            {
                if( rows_working_counter < dot1dTpFdbEntry_rowNumber )
                    rows_working_counter++;

                if( table_rebuild_flag == 1 )
                {
                    rebuild_dot1dTpFdbEntry();
                    table_rebuild_flag = 0;
                }   
            }
            else
                rebuild_dot1dTpFdbEntry();

            memcpy(string, geptr->address, ETH_MAC_LEN);
            *var_len = ETH_MAC_LEN;
            return (u_char*) &string;

        case DOT1DTPFDBPORT:                                             //[2]
            if( exact )
                rebuild_dot1dTpFdbEntry();

            ulong_ret = geptr->port;
            return (u_char *) &ulong_ret;

        case DOT1DTPFDBSTATUS:                                           //[3]
            if( !exact )
            {
                if( rows_working_counter > 0 )
                    rows_working_counter--;

                if( rows_working_counter==0 )
                    table_rebuild_flag = 1; 
            }
            else
                rebuild_dot1dTpFdbEntry();
            
            ulong_ret = geptr->status;
            return (u_char *) &ulong_ret;

        default:
            ERROR_MSG("var_dot1dTpFdbTable() Fail");
    }

    return NULL;
}

// *********************************************************************** //
// PART 8 SNMP Get/GetNext Table_Handle Functon                            //
// *********************************************************************** //
// *********************************************************************** //
// [8-1] SNMP Get/GetNext Table_Handle Functon                             //
// *********************************************************************** //
// *********************************************************************** //
// unsigned char address[6];      MacAddress - ASN_OCTET_STR         [3][1]*
// long port;                     INTEGER - ASN_INTEGER              [3][2]
// long status;                   INTEGER - ASN_INTEGER              [3][3]
// *********************************************************************** //
struct MIB_dot1dTpPortEntry *get_dot1dTpPortEntry(long index)
{
    long curr_index_value, row;
	
    curr_index_value = index;
    for( row=0 ; row < dot1dTpPortEntry_rowNumber ; row++ )
    {
        if( curr_index_value == dot1dTpPortEntry[row].port )
            break;
    }
	
    if( row == dot1dTpPortEntry_rowNumber )
        return NULL;// [twh] not found

    return (struct MIB_dot1dTpPortEntry *)&dot1dTpPortEntry[row]; 
}

struct MIB_dot1dTpPortEntry *getnext_dot1dTpPortEntry(long index)
{
    long curr_index_value, row;

    curr_index_value = index;
    for( row=0 ; row < dot1dTpPortEntry_rowNumber ; row++ )
    {
        if( curr_index_value < dot1dTpPortEntry[row].port )
            break;
    }

    if( row == dot1dTpPortEntry_rowNumber )
        return NULL; // [twh] not found

    return (struct MIB_dot1dTpPortEntry*)&dot1dTpPortEntry[row]; 
}

// *********************************************************************** 
// [8-2]     SNMP Get/GetNext Table_Handle Functon               
// long port;                      // INTEGER - ASN_INTEGER           [4][1]
// long maxInfo;                   // INTEGER - ASN_INTEGER           [4][2]
// u_long inFrames;                // Counter - ASN_COUNTER           [4][3]
// u_long outFrames;               // Counter - ASN_COUNTER           [4][4]
// u_long inDiscards;              // Counter - ASN_COUNTER           [4][5]
// ********************************************************************** 
/*
 * var_dot1TpPortTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_ above.
 */
unsigned char *var_dot1dTpPortTable( struct variable *vp, oid *name,
                                     size_t *length, int exact,
                                     size_t *var_len, WriteMethod **write_method )
{
    static u_long   ulong_ret;
    u_long          index;
    snmp_eventMsg_t event;
    struct MIB_dot1dTpPortEntry *geptr;

    // 1,3,6,1,2,1,17,1,4,1,item
    //                      11 
    // 1,3,6,1,2,1,17,1,4,1,item,[port]
    //                            12

 /* Set up write_method first, in case we return NULL before getting to
    the switch (vp->magic) below.  In some of these cases, we still want
    to call the appropriate write_method, if only to have it return the
    appropriate error.  */

    *write_method = NULL;

    if( memcmp(name, vp->name, sizeof(oid)*vp->namelen) != 0 )
    {
        memcpy(name, vp->name, sizeof(oid)*vp->namelen);
        *length = vp->namelen;
    }

    if( exact )
    { //[twh][get, set]
        if( *length != 12 )
            return NULL;
        index = name[11];
        geptr = get_dot1dTpPortEntry(index);
    }
    else
    { //[twh][getnext]
        index = *length>11 ? name[11] : 0;
        //[twh][92:05:23] for table: first time index==0
        geptr = getnext_dot1dTpPortEntry(index);
        if( geptr )
        { 
    	    name[11] = geptr->port;
            *length = 12;
        } 	
    }	

    if( geptr == NULL )
        return NULL;
    
 /* This is where we do the value assignments for the mib results. */
    memset( &event, 0, sizeof(snmp_eventMsg_t) );
    *var_len = sizeof(ulong_ret);
    event.port = (unsigned int)index+1;
    switch( vp->magic )
    {
        case DOT1DTPPORT:                               //[1]
            ulong_ret = geptr->port;
            *var_len = sizeof(ulong_ret);
            return (u_char *) &ulong_ret;

        case DOT1DTPPORTMAXINFO:                        //[2]
            event.type=e_snmp_dot1dTpPortMaxInfo_get;
            util_snmp_evtMsg_ack_handler( &event );
            ulong_ret=event.val;
            return (u_char *) &ulong_ret;

        case DOT1DTPPORTINFRAMES:                       //[3]
            event.type=e_snmp_dot1dTpPortInFrames_get;
            util_snmp_evtMsg_ack_handler( &event );
            ulong_ret=event.val;
            return (u_char *) &ulong_ret;

        case DOT1DTPPORTOUTFRAMES:                       //[4]
            event.type=e_snmp_dot1dTpPortOutFrames_get;
            util_snmp_evtMsg_ack_handler( &event );
            ulong_ret=event.val;
            return (u_char *) &ulong_ret;

        case DOT1DTPPORTINDISCARDS:                      //[5]
            event.type=e_snmp_dot1dTpPortInDiscards_get;
            util_snmp_evtMsg_ack_handler( &event );
            ulong_ret=event.val;
            return (u_char *) &ulong_ret;

        default:
            ERROR_MSG("var_dot1dTpPortTable() Fail");
    }
    return NULL;
}

// *********************************************************************** //
// [9-0]     SNMP write_handle Functon 
// *********************************************************************** //
// Parameters:
//	 action
//	*var_val	OID of auth transform to set.
//	 var_val_type
//	 var_val_len
//	*statP
//	*name		OID of user upon which to perform set operation.
//	 name_len
//      
// Returns:
//  SNMP_ERR_NOERROR		On success.
// 	SNMP_ERR_GENERR
//	SNMP_ERR_INCONSISTENTVALUE
//	SNMP_ERR_NOSUCHNAME
//	SNMP_ERR_WRONGLENGTH
//	SNMP_ERR_WRONGTYPE

// *********************************************************************** //
// [9-1-1] SNMP write_handle Functon 
// long agingTime;                INTEGER - ASN_INTEGER              [2]rw
// *********************************************************************** //
int write_dot1dTpAgingTime( int action, u_char *var_val, u_char var_val_type, 
                            size_t var_val_len, u_char *statP, oid *name, 
                            size_t name_len )
{
    long            newValue = *((long*) var_val);
    static long     oldValue;
    snmp_eventMsg_t event;

    if( action == RESERVE1 )
    {
        if( var_val_type != ASN_INTEGER )
        {
            fprintf(stderr, "write to dot1dTpAgingTime not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }

        if( var_val_len > sizeof(long) )
        {
            fprintf(stderr,"write to dot1dTpAgingTime: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }

        if( newValue<10 || newValue>1000000L )
            return SNMP_ERR_WRONGVALUE;
    }

    if( action == RESERVE2 )
    {
        oldValue = dot1dTpScalar.agingTime;
        dot1dTpScalar.agingTime = newValue;

        event.type = e_snmp_dot1dTpAgingTime_set;
        event.val = newValue;
        fprintf(stderr,"%s %d, %d\n", __func__, event.type, event.val);
        if( util_snmp_evtMsg_handler(&event) )
            return SNMP_ERR_INCONSISTENTVALUE;
    }

    if( action == FREE )
    {
	 /* Try to undo the SET here (abnormal usage of FREE clause) */
        dot1dTpScalar.agingTime = oldValue;
    } 
    return SNMP_ERR_NOERROR;
}
