/** @file rx_sm.h
 *
 * OpenLLDP RX Statemachine Header
 *
 * See LICENSE file for more info.
 * 
 * File: rx_sm.h
 * 
 * Authors: Terry Simons (terry.simons@gmail.com)
 *
 *******************************************************************/

#ifndef RX_SM_H
#define RX_SM_H

#include <stdint.h>
#include "lldp_port.h"

// States from the receive state machine diagram (IEEE 802.1AB 10.5.5.3)
#define LLDP_WAIT_PORT_OPERATIONAL 4
#define DELETE_AGED_INFO           5
#define RX_LLDP_INITIALIZE         6
#define RX_WAIT_FOR_FRAME          7
#define RX_FRAME                   8
#define DELETE_INFO                9
#define UPDATE_INFO                10

/* Defined by the 802.1AB specification */
uint8_t rxInitializeLLDP(struct lldp_port *lldp);
/* End Defined by the 802.1AB specification */

/* Utility functions not defined in the specification */
void rxStatemachineRun(struct lldp_port *lldp_port);
/* End Utility functions not defined in the specification */

#endif /* RX_SM_H */
